
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class RecommendationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const recommendations = await db.recommendations.create(
            {
                id: data.id || undefined,
        
        recommendation_type: data.recommendation_type
        ||
        null
            ,
            
        priority: data.priority
        ||
        null
            ,
            
        title_text: data.title_text
        ||
        null
            ,
            
        rationale: data.rationale
        ||
        null
            ,
            
        action_steps: data.action_steps
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        created_on: data.created_on
        ||
        null
            ,
            
        due_on: data.due_on
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await recommendations.setWorkspace( data.workspace || null, {
            transaction,
        });
        
        await recommendations.setAssigned_to( data.assigned_to || null, {
            transaction,
        });
        
        await recommendations.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return recommendations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const recommendationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                recommendation_type: item.recommendation_type
            ||
            null
            ,
            
                priority: item.priority
            ||
            null
            ,
            
                title_text: item.title_text
            ||
            null
            ,
            
                rationale: item.rationale
            ||
            null
            ,
            
                action_steps: item.action_steps
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                created_on: item.created_on
            ||
            null
            ,
            
                due_on: item.due_on
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const recommendations = await db.recommendations.bulkCreate(recommendationsData, { transaction });

        // For each item created, replace relation files
        

        return recommendations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const recommendations = await db.recommendations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.recommendation_type !== undefined) updatePayload.recommendation_type = data.recommendation_type;
        
        
        if (data.priority !== undefined) updatePayload.priority = data.priority;
        
        
        if (data.title_text !== undefined) updatePayload.title_text = data.title_text;
        
        
        if (data.rationale !== undefined) updatePayload.rationale = data.rationale;
        
        
        if (data.action_steps !== undefined) updatePayload.action_steps = data.action_steps;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.created_on !== undefined) updatePayload.created_on = data.created_on;
        
        
        if (data.due_on !== undefined) updatePayload.due_on = data.due_on;
        
        
        updatePayload.updatedById = currentUser.id;

        await recommendations.update(updatePayload, {transaction});

        
        
        if (data.workspace !== undefined) {
            await recommendations.setWorkspace(
              
              data.workspace,
              
              { transaction }
            );
        }
        
        if (data.assigned_to !== undefined) {
            await recommendations.setAssigned_to(
              
              data.assigned_to,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await recommendations.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return recommendations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const recommendations = await db.recommendations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of recommendations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of recommendations) {
                await record.destroy({transaction});
            }
        });


        return recommendations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const recommendations = await db.recommendations.findByPk(id, options);

        await recommendations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await recommendations.destroy({
            transaction
        });

        return recommendations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const recommendations = await db.recommendations.findOne(
            { where },
            { transaction },
        );

        if (!recommendations) {
            return recommendations;
        }

        const output = recommendations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.workspace = await recommendations.getWorkspace({
            transaction
        });
        
        
        output.assigned_to = await recommendations.getAssigned_to({
            transaction
        });
        
        
        output.organizations = await recommendations.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.workspaces,
        as: 'workspace',
        
        where: filter.workspace ? {
          [Op.or]: [
            { id: { [Op.in]: filter.workspace.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.workspace.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'assigned_to',
        
        where: filter.assigned_to ? {
          [Op.or]: [
            { id: { [Op.in]: filter.assigned_to.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.assigned_to.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'recommendations',
                        'title_text',
                        filter.title_text,
                    ),
                };
            }
            
            if (filter.rationale) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'recommendations',
                        'rationale',
                        filter.rationale,
                    ),
                };
            }
            
            if (filter.action_steps) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'recommendations',
                        'action_steps',
                        filter.action_steps,
                    ),
                };
            }
            

            
            

            
            if (filter.created_onRange) {
                const [start, end] = filter.created_onRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    created_on: {
                    ...where.created_on,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    created_on: {
                    ...where.created_on,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.due_onRange) {
                const [start, end] = filter.due_onRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    due_on: {
                    ...where.due_on,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    due_on: {
                    ...where.due_on,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.recommendation_type) {
                where = {
                    ...where,
                recommendation_type: filter.recommendation_type,
            };
            }
            
            if (filter.priority) {
                where = {
                    ...where,
                priority: filter.priority,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.recommendations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'recommendations',
                        'title_text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.recommendations.findAll({
            attributes: [ 'id', 'title_text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title_text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title_text,
        }));
    }

    
};

